


<!DOCTYPE html>
<html>
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8">
    
    
    <meta http-equiv="X-UA-Compatible" content="IE=emulateIE7" />
    <title>Coverage for /private/tmp/im/impacket/impacket/examples/ntlmrelayx/attacks/__init__.py: 65%</title>
    <link rel="stylesheet" href="style.css" type="text/css">
    
    <script type="text/javascript" src="jquery.min.js"></script>
    <script type="text/javascript" src="jquery.hotkeys.js"></script>
    <script type="text/javascript" src="jquery.isonscreen.js"></script>
    <script type="text/javascript" src="coverage_html.js"></script>
    <script type="text/javascript">
        jQuery(document).ready(coverage.pyfile_ready);
    </script>
</head>
<body class="pyfile">

<div id="header">
    <div class="content">
        <h1>Coverage for <b>/private/tmp/im/impacket/impacket/examples/ntlmrelayx/attacks/__init__.py</b> :
            <span class="pc_cov">65%</span>
        </h1>

        <img id="keyboard_icon" src="keybd_closed.png" alt="Show keyboard shortcuts" />

        <h2 class="stats">
            40 statements &nbsp;
            <span class="run hide_run shortkey_r button_toggle_run">25 run</span>
            <span class="mis shortkey_m button_toggle_mis">15 missing</span>
            <span class="exc shortkey_x button_toggle_exc">0 excluded</span>

            
                <span class="par run hide_run shortkey_p button_toggle_par">1 partial</span>
            
        </h2>
    </div>
</div>

<div class="help_panel">
    <img id="panel_icon" src="keybd_open.png" alt="Hide keyboard shortcuts" />
    <p class="legend">Hot-keys on this page</p>
    <div>
    <p class="keyhelp">
        <span class="key">r</span>
        <span class="key">m</span>
        <span class="key">x</span>
        <span class="key">p</span> &nbsp; toggle line displays
    </p>
    <p class="keyhelp">
        <span class="key">j</span>
        <span class="key">k</span> &nbsp; next/prev highlighted chunk
    </p>
    <p class="keyhelp">
        <span class="key">0</span> &nbsp; (zero) top of page
    </p>
    <p class="keyhelp">
        <span class="key">1</span> &nbsp; (one) first highlighted chunk
    </p>
    </div>
</div>

<div id="source">
    <table>
        <tr>
            <td class="linenos">
<p id="n1" class="pln"><a href="#n1">1</a></p>
<p id="n2" class="pln"><a href="#n2">2</a></p>
<p id="n3" class="pln"><a href="#n3">3</a></p>
<p id="n4" class="pln"><a href="#n4">4</a></p>
<p id="n5" class="pln"><a href="#n5">5</a></p>
<p id="n6" class="pln"><a href="#n6">6</a></p>
<p id="n7" class="pln"><a href="#n7">7</a></p>
<p id="n8" class="pln"><a href="#n8">8</a></p>
<p id="n9" class="pln"><a href="#n9">9</a></p>
<p id="n10" class="pln"><a href="#n10">10</a></p>
<p id="n11" class="pln"><a href="#n11">11</a></p>
<p id="n12" class="pln"><a href="#n12">12</a></p>
<p id="n13" class="pln"><a href="#n13">13</a></p>
<p id="n14" class="pln"><a href="#n14">14</a></p>
<p id="n15" class="pln"><a href="#n15">15</a></p>
<p id="n16" class="pln"><a href="#n16">16</a></p>
<p id="n17" class="pln"><a href="#n17">17</a></p>
<p id="n18" class="stm run hide_run"><a href="#n18">18</a></p>
<p id="n19" class="stm run hide_run"><a href="#n19">19</a></p>
<p id="n20" class="stm run hide_run"><a href="#n20">20</a></p>
<p id="n21" class="stm run hide_run"><a href="#n21">21</a></p>
<p id="n22" class="pln"><a href="#n22">22</a></p>
<p id="n23" class="stm run hide_run"><a href="#n23">23</a></p>
<p id="n24" class="pln"><a href="#n24">24</a></p>
<p id="n25" class="pln"><a href="#n25">25</a></p>
<p id="n26" class="pln"><a href="#n26">26</a></p>
<p id="n27" class="pln"><a href="#n27">27</a></p>
<p id="n28" class="pln"><a href="#n28">28</a></p>
<p id="n29" class="pln"><a href="#n29">29</a></p>
<p id="n30" class="pln"><a href="#n30">30</a></p>
<p id="n31" class="pln"><a href="#n31">31</a></p>
<p id="n32" class="pln"><a href="#n32">32</a></p>
<p id="n33" class="stm run hide_run"><a href="#n33">33</a></p>
<p id="n34" class="stm run hide_run"><a href="#n34">34</a></p>
<p id="n35" class="stm run hide_run"><a href="#n35">35</a></p>
<p id="n36" class="stm mis"><a href="#n36">36</a></p>
<p id="n37" class="pln"><a href="#n37">37</a></p>
<p id="n38" class="stm mis"><a href="#n38">38</a></p>
<p id="n39" class="stm mis"><a href="#n39">39</a></p>
<p id="n40" class="stm mis"><a href="#n40">40</a></p>
<p id="n41" class="pln"><a href="#n41">41</a></p>
<p id="n42" class="stm mis"><a href="#n42">42</a></p>
<p id="n43" class="pln"><a href="#n43">43</a></p>
<p id="n44" class="stm run hide_run"><a href="#n44">44</a></p>
<p id="n45" class="stm mis"><a href="#n45">45</a></p>
<p id="n46" class="pln"><a href="#n46">46</a></p>
<p id="n47" class="stm run hide_run"><a href="#n47">47</a></p>
<p id="n48" class="stm run hide_run"><a href="#n48">48</a></p>
<p id="n49" class="stm run hide_run"><a href="#n49">49</a></p>
<p id="n50" class="pln"><a href="#n50">50</a></p>
<p id="n51" class="pln"><a href="#n51">51</a></p>
<p id="n52" class="pln"><a href="#n52">52</a></p>
<p id="n53" class="stm run hide_run"><a href="#n53">53</a></p>
<p id="n54" class="stm run hide_run"><a href="#n54">54</a></p>
<p id="n55" class="stm mis"><a href="#n55">55</a></p>
<p id="n56" class="stm mis"><a href="#n56">56</a></p>
<p id="n57" class="stm run hide_run"><a href="#n57">57</a></p>
<p id="n58" class="stm run hide_run"><a href="#n58">58</a></p>
<p id="n59" class="stm run hide_run"><a href="#n59">59</a></p>
<p id="n60" class="stm run hide_run"><a href="#n60">60</a></p>
<p id="n61" class="stm run hide_run"><a href="#n61">61</a></p>
<p id="n62" class="stm par run hide_run"><a href="#n62">62</a></p>
<p id="n63" class="pln"><a href="#n63">63</a></p>
<p id="n64" class="stm mis"><a href="#n64">64</a></p>
<p id="n65" class="stm mis"><a href="#n65">65</a></p>
<p id="n66" class="pln"><a href="#n66">66</a></p>
<p id="n67" class="pln"><a href="#n67">67</a></p>
<p id="n68" class="stm run hide_run"><a href="#n68">68</a></p>
<p id="n69" class="stm mis"><a href="#n69">69</a></p>
<p id="n70" class="stm mis"><a href="#n70">70</a></p>
<p id="n71" class="stm mis"><a href="#n71">71</a></p>
<p id="n72" class="pln"><a href="#n72">72</a></p>
<p id="n73" class="stm run hide_run"><a href="#n73">73</a></p>
<p id="n74" class="stm run hide_run"><a href="#n74">74</a></p>
<p id="n75" class="stm run hide_run"><a href="#n75">75</a></p>
<p id="n76" class="stm run hide_run"><a href="#n76">76</a></p>
<p id="n77" class="stm mis"><a href="#n77">77</a></p>
<p id="n78" class="stm mis"><a href="#n78">78</a></p>

            </td>
            <td class="text">
<p id="t1" class="pln"><span class="com"># Copyright (c) 2013-2017 CORE Security Technologies</span><span class="strut">&nbsp;</span></p>
<p id="t2" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t3" class="pln"><span class="com"># This software is provided under under a slightly modified version</span><span class="strut">&nbsp;</span></p>
<p id="t4" class="pln"><span class="com"># of the Apache Software License. See the accompanying LICENSE file</span><span class="strut">&nbsp;</span></p>
<p id="t5" class="pln"><span class="com"># for more information.</span><span class="strut">&nbsp;</span></p>
<p id="t6" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t7" class="pln"><span class="com"># Protocol Attack Base Class definition</span><span class="strut">&nbsp;</span></p>
<p id="t8" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t9" class="pln"><span class="com"># Authors:</span><span class="strut">&nbsp;</span></p>
<p id="t10" class="pln"><span class="com">#  Alberto Solino (@agsolino)</span><span class="strut">&nbsp;</span></p>
<p id="t11" class="pln"><span class="com">#  Dirk-jan Mollema (@_dirkjan) / Fox-IT (https://www.fox-it.com)</span><span class="strut">&nbsp;</span></p>
<p id="t12" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t13" class="pln"><span class="com"># Description:</span><span class="strut">&nbsp;</span></p>
<p id="t14" class="pln"><span class="com">#  Defines a base class for all attacks + loads all available modules</span><span class="strut">&nbsp;</span></p>
<p id="t15" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t16" class="pln"><span class="com"># ToDo:</span><span class="strut">&nbsp;</span></p>
<p id="t17" class="pln"><span class="com">#</span><span class="strut">&nbsp;</span></p>
<p id="t18" class="stm run hide_run"><span class="key">import</span> <span class="nam">os</span><span class="op">,</span> <span class="nam">sys</span><span class="strut">&nbsp;</span></p>
<p id="t19" class="stm run hide_run"><span class="key">import</span> <span class="nam">pkg_resources</span><span class="strut">&nbsp;</span></p>
<p id="t20" class="stm run hide_run"><span class="key">from</span> <span class="nam">impacket</span> <span class="key">import</span> <span class="nam">LOG</span><span class="strut">&nbsp;</span></p>
<p id="t21" class="stm run hide_run"><span class="key">from</span> <span class="nam">threading</span> <span class="key">import</span> <span class="nam">Thread</span><span class="strut">&nbsp;</span></p>
<p id="t22" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t23" class="stm run hide_run"><span class="nam">PROTOCOL_ATTACKS</span> <span class="op">=</span> <span class="op">{</span><span class="op">}</span><span class="strut">&nbsp;</span></p>
<p id="t24" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t25" class="pln"><span class="com"># Base class for Protocol Attacks for different protocols (SMB, MSSQL, etc)</span><span class="strut">&nbsp;</span></p>
<p id="t26" class="pln"><span class="com"># Besides using this base class you need to define one global variable when</span><span class="strut">&nbsp;</span></p>
<p id="t27" class="pln"><span class="com"># writing a plugin for protocol clients:</span><span class="strut">&nbsp;</span></p>
<p id="t28" class="pln"><span class="com">#     PROTOCOL_ATTACK_CLASS = "&lt;name of the class for the plugin>"</span><span class="strut">&nbsp;</span></p>
<p id="t29" class="pln"><span class="com"># or (to support multiple classes in one file)</span><span class="strut">&nbsp;</span></p>
<p id="t30" class="pln"><span class="com">#     PROTOCOL_ATTACK_CLASSES = ["&lt;name of the class for the plugin>", "&lt;another class>"]</span><span class="strut">&nbsp;</span></p>
<p id="t31" class="pln"><span class="com"># These classes must have the attribute PLUGIN_NAMES which is a list of protocol names</span><span class="strut">&nbsp;</span></p>
<p id="t32" class="pln"><span class="com"># that will be matched later with the relay targets (e.g. SMB, LDAP, etc)</span><span class="strut">&nbsp;</span></p>
<p id="t33" class="stm run hide_run"><span class="key">class</span> <span class="nam">ProtocolAttack</span><span class="op">(</span><span class="nam">Thread</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t34" class="stm run hide_run">    <span class="nam">PLUGIN_NAMES</span> <span class="op">=</span> <span class="op">[</span><span class="str">'PROTOCOL'</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t35" class="stm run hide_run">    <span class="key">def</span> <span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">,</span> <span class="nam">config</span><span class="op">,</span> <span class="nam">client</span><span class="op">,</span> <span class="nam">username</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t36" class="stm mis">        <span class="nam">Thread</span><span class="op">.</span><span class="nam">__init__</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t37" class="pln">        <span class="com"># Set threads as daemon</span><span class="strut">&nbsp;</span></p>
<p id="t38" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">daemon</span> <span class="op">=</span> <span class="key">True</span><span class="strut">&nbsp;</span></p>
<p id="t39" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">config</span> <span class="op">=</span> <span class="nam">config</span><span class="strut">&nbsp;</span></p>
<p id="t40" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">client</span> <span class="op">=</span> <span class="nam">client</span><span class="strut">&nbsp;</span></p>
<p id="t41" class="pln">        <span class="com"># By default we only use the username and remove the domain</span><span class="strut">&nbsp;</span></p>
<p id="t42" class="stm mis">        <span class="nam">self</span><span class="op">.</span><span class="nam">username</span> <span class="op">=</span> <span class="nam">username</span><span class="op">.</span><span class="nam">split</span><span class="op">(</span><span class="str">'/'</span><span class="op">)</span><span class="op">[</span><span class="num">1</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t43" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t44" class="stm run hide_run">    <span class="key">def</span> <span class="nam">run</span><span class="op">(</span><span class="nam">self</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t45" class="stm mis">        <span class="key">raise</span> <span class="nam">RuntimeError</span><span class="op">(</span><span class="str">'Virtual Function'</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t46" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t47" class="stm run hide_run"><span class="key">for</span> <span class="nam">file</span> <span class="key">in</span> <span class="nam">pkg_resources</span><span class="op">.</span><span class="nam">resource_listdir</span><span class="op">(</span><span class="str">'impacket.examples.ntlmrelayx'</span><span class="op">,</span> <span class="str">'attacks'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t48" class="stm run hide_run">    <span class="key">if</span> <span class="nam">file</span><span class="op">.</span><span class="nam">find</span><span class="op">(</span><span class="str">'__'</span><span class="op">)</span> <span class="op">>=</span> <span class="num">0</span> <span class="key">or</span> <span class="nam">file</span><span class="op">.</span><span class="nam">endswith</span><span class="op">(</span><span class="str">'.py'</span><span class="op">)</span> <span class="key">is</span> <span class="key">False</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t49" class="stm run hide_run">        <span class="key">continue</span><span class="strut">&nbsp;</span></p>
<p id="t50" class="pln">    <span class="com"># This seems to be None in some case (py3 only)</span><span class="strut">&nbsp;</span></p>
<p id="t51" class="pln">    <span class="com"># __spec__ is py3 only though, but I haven't seen this being None on py2</span><span class="strut">&nbsp;</span></p>
<p id="t52" class="pln">    <span class="com"># so it should cover all cases.</span><span class="strut">&nbsp;</span></p>
<p id="t53" class="stm run hide_run">    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t54" class="stm run hide_run">        <span class="nam">package</span> <span class="op">=</span> <span class="nam">__spec__</span><span class="op">.</span><span class="nam">name</span>  <span class="com"># Python 3</span><span class="strut">&nbsp;</span></p>
<p id="t55" class="stm mis">    <span class="key">except</span> <span class="nam">NameError</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t56" class="stm mis">        <span class="nam">package</span> <span class="op">=</span> <span class="nam">__package__</span>    <span class="com"># Python 2</span><span class="strut">&nbsp;</span></p>
<p id="t57" class="stm run hide_run">    <span class="nam">__import__</span><span class="op">(</span><span class="nam">package</span> <span class="op">+</span> <span class="str">'.'</span> <span class="op">+</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">splitext</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t58" class="stm run hide_run">    <span class="nam">module</span> <span class="op">=</span> <span class="nam">sys</span><span class="op">.</span><span class="nam">modules</span><span class="op">[</span><span class="nam">package</span> <span class="op">+</span> <span class="str">'.'</span> <span class="op">+</span> <span class="nam">os</span><span class="op">.</span><span class="nam">path</span><span class="op">.</span><span class="nam">splitext</span><span class="op">(</span><span class="nam">file</span><span class="op">)</span><span class="op">[</span><span class="num">0</span><span class="op">]</span><span class="op">]</span><span class="strut">&nbsp;</span></p>
<p id="t59" class="stm run hide_run">    <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t60" class="stm run hide_run">        <span class="nam">pluginClasses</span> <span class="op">=</span> <span class="nam">set</span><span class="op">(</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t61" class="stm run hide_run">        <span class="key">try</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t62" class="stm par run hide_run"><span class="annotate short">62&#x202F;&#x219B;&#x202F;64</span><span class="annotate long">line 62 didn't jump to line 64, because the condition on line 62 was never true</span>            <span class="key">if</span> <span class="nam">hasattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="str">'PROTOCOL_ATTACK_CLASSES'</span><span class="op">)</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t63" class="pln">                <span class="com"># Multiple classes</span><span class="strut">&nbsp;</span></p>
<p id="t64" class="stm mis">                <span class="key">for</span> <span class="nam">pluginClass</span> <span class="key">in</span> <span class="nam">module</span><span class="op">.</span><span class="nam">PROTOCOL_ATTACK_CLASSES</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t65" class="stm mis">                    <span class="nam">pluginClasses</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="nam">pluginClass</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t66" class="pln">            <span class="key">else</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t67" class="pln">                <span class="com"># Single class</span><span class="strut">&nbsp;</span></p>
<p id="t68" class="stm run hide_run">                <span class="nam">pluginClasses</span><span class="op">.</span><span class="nam">add</span><span class="op">(</span><span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="nam">getattr</span><span class="op">(</span><span class="nam">module</span><span class="op">,</span> <span class="str">'PROTOCOL_ATTACK_CLASS'</span><span class="op">)</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t69" class="stm mis">        <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t70" class="stm mis">            <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t71" class="stm mis">            <span class="key">pass</span><span class="strut">&nbsp;</span></p>
<p id="t72" class="pln"><span class="strut">&nbsp;</span></p>
<p id="t73" class="stm run hide_run">        <span class="key">for</span> <span class="nam">pluginClass</span> <span class="key">in</span> <span class="nam">pluginClasses</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t74" class="stm run hide_run">            <span class="key">for</span> <span class="nam">pluginName</span> <span class="key">in</span> <span class="nam">pluginClass</span><span class="op">.</span><span class="nam">PLUGIN_NAMES</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t75" class="stm run hide_run">                <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="str">'Protocol Attack %s loaded..'</span> <span class="op">%</span> <span class="nam">pluginName</span><span class="op">)</span><span class="strut">&nbsp;</span></p>
<p id="t76" class="stm run hide_run">                <span class="nam">PROTOCOL_ATTACKS</span><span class="op">[</span><span class="nam">pluginName</span><span class="op">]</span> <span class="op">=</span> <span class="nam">pluginClass</span><span class="strut">&nbsp;</span></p>
<p id="t77" class="stm mis">    <span class="key">except</span> <span class="nam">Exception</span> <span class="key">as</span> <span class="nam">e</span><span class="op">:</span><span class="strut">&nbsp;</span></p>
<p id="t78" class="stm mis">        <span class="nam">LOG</span><span class="op">.</span><span class="nam">debug</span><span class="op">(</span><span class="nam">str</span><span class="op">(</span><span class="nam">e</span><span class="op">)</span><span class="op">)</span><span class="strut">&nbsp;</span></p>

            </td>
        </tr>
    </table>
</div>

<div id="footer">
    <div class="content">
        <p>
            <a class="nav" href="index.html">&#xab; index</a> &nbsp; &nbsp; <a class="nav" href="https://coverage.readthedocs.io">coverage.py v4.5.4</a>,
            created at 2019-09-25 12:47
        </p>
    </div>
</div>

</body>
</html>
